<template>
  <div class="app-container mag-detail-index">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="期刊" prop="magid">

        <el-button type="text">管理</el-button>
      </el-form-item>
      <el-form-item label="栏目" prop="topic">
        <el-select v-model="queryParams.type" placeholder="请选择栏目" clearable>
          <el-option v-for="dict in dict.type.base_mag_topic" :key="dict.value" :label="dict.label"
            :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['base:magDetail:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['base:magDetail:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['base:magDetail:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5" v-if="1 == 2">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['base:magDetail:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="magDetailList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="期刊" align="center" prop="name" />
      <el-table-column label="栏目" align="center" prop="topicName" />
      <el-table-column label="单位" align="center" prop="deptName" />
      <el-table-column label="作者" align="center" prop="authorName" />
      <el-table-column label="期刊主图" align="center" prop="imageUrl">
        <template slot-scope="{row}">
          <el-image v-if="row.imageUrl" class="row-image" :src="row.imageUrl[0] + '.min.jpg'"
            :preview-src-list="row.imageUrl"></el-image>
        </template>
      </el-table-column>
      <el-table-column label="标题" align="center" prop="title">
        <template slot-scope="{row}">
          <el-popover placement="bottom-start" width="400" trigger="hover">
            {{ row.title }}
            <div slot="reference" class="div-txt-3" style="text-align: left;">{{ row.title }}</div>
          </el-popover>

        </template>
      </el-table-column>
      <el-table-column label="排序号" align="center" prop="ord" />
      <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['base:magDetail:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['base:magDetail:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改期刊详情对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="期刊id" prop="magid">
          <el-input v-model="form.magid" placeholder="请输入期刊id" />
        </el-form-item>
        <el-form-item label="栏目字典mag_topic" prop="topic">
          <el-input v-model="form.topic" placeholder="请输入栏目字典mag_topic" />
        </el-form-item>
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="总包编号" prop="deptid">
          <el-input v-model="form.deptid" placeholder="请输入总包编号" />
        </el-form-item>
        <el-form-item label="作者" prop="authorName">
          <el-input v-model="form.authorName" placeholder="请输入作者" />
        </el-form-item>
        <el-form-item label="作者电话" prop="authorPhone">
          <el-input v-model="form.authorPhone" placeholder="请输入作者电话" />
        </el-form-item>
        <el-form-item label="排序号" prop="ord">
          <el-input v-model="form.ord" placeholder="请输入排序号" />
        </el-form-item>
        <el-form-item label="图片" prop="images">
          <el-input v-model="form.images" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="正文">
          <editor v-model="form.content" :min-height="192" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="${comment}" prop="isDel">
          <el-input v-model="form.isDel" placeholder="请输入${comment}" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <magDetailDrawer ref="drawer" @success="getList"></magDetailDrawer>
  </div>
</template>

<script>
import { listMagDetail, getMagDetail, delMagDetail, addMagDetail, updateMagDetail } from "@/api/base/magDetail";
import magDetailDrawer from './magDetailDrawer.vue'
export default {
  dicts: ['base_mag_topic'],
  name: "MagDetail",
  components: {
    magDetailDrawer,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 期刊详情表格数据
      magDetailList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        magid: null,
        topic: null,
        title: null,
        deptid: null,
        authorName: null,
        authorPhone: null,
        ord: null,
        images: null,
        content: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询期刊详情列表 */
    getList() {
      this.loading = true;
      listMagDetail(this.queryParams).then(response => {
        this.magDetailList = (response.rows || []).map(it => {
          let tmps = it.images;
          if (tmps && tmps.length > 0) {
            tmps = this.$tryToJson(tmps, []);
            if (tmps.length > 0) {
              it.imageUrl = tmps.map(it=>{
                return this.$basepath+it;
              });
            }
          }
          return it;
        });
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        magid: null,
        topic: null,
        title: null,
        deptid: null,
        authorName: null,
        authorPhone: null,
        ord: null,
        images: null,
        content: null,
        remark: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$refs.drawer.show(null, this.total + 1);
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$refs.drawer.show(row, this.total + 1);
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateMagDetail(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMagDetail(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除期刊详情编号为"' + ids + '"的数据项？').then(function () {
        return delMagDetail(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('base/magDetail/export', {
        ...this.queryParams
      }, `magDetail_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style lang="scss">
.mag-detail-index {
  .row-image {
    height: 100px;
  }
}
</style>